﻿' RasterPS - Main Window
' Apr 2013 M.P.

Public Class FormRasterPS

    ' -   Sub displayState: Display State of Calculation

    Private Sub FormRasterPS_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Initialization

        ' Language
        pubLanguage = enumLang.English

        ' Image
        HScrollBar1.Dock = DockStyle.Bottom
        VScrollBar1.Dock = DockStyle.Right
        HScrollBar1.Parent = PictureBoxImage
        VScrollBar1.Parent = PictureBoxImage
        HScrollBar1.Visible = False
        VScrollBar1.Visible = False

        ' Result
        ComboBoxColorSpace.Items.Add("RGB")
        ComboBoxColorSpace.Items.Add("CMY")
        ComboBoxColorSpace.Items.Add("HSV")
        ComboBoxColorSpace.Items.Add("HLS")
        ComboBoxColorSpace.SelectedIndex = 0

        ' Graphics: Image
        objgr_image = Me.PictureBoxImage.CreateGraphics

        ' Graphics: Result
        objgr_result = Me.PictureBoxResult.CreateGraphics

        ' Pick
        pubpick_done = False

        ' Window: Parameter
        pubWinPar = New FormParameter

    End Sub

    Private Sub NewToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewToolStripMenuItem.Click
        ' New Session
        Dim img = New System.Drawing.Bitmap(1, 1)

        ' Bild loeschen
        PictureBoxImage.Image = img
        PictureBoxImage.Tag = ""

        ' Result loeschen
        objgr_result.Clear(Color.Silver)

        ' State loeschen
        Me.LabelState.Text = "State"
        Me.LabelState.BackColor = Color.LightGoldenrodYellow

        ' Scroll Bars setzen
        setImageScrollBars()

    End Sub

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        ' Open File
        Dim img As System.Drawing.Bitmap
        Dim locRPSindexedImg As New RPSindexedImg
        Dim histo As New RPShistogram
        Dim fimg As String
        Dim reti As Integer

        ' Default
        fimg = ""

        ' Datei-Auswahl
        Me.OpenFileDialog1.InitialDirectory = Application.StartupPath
        If (pubLanguage = enumLang.Deutsch) Then
            OpenFileDialog1.Filter = "Bilder (*.bmp;*.gif;*.jpg;*.png;*.tif;*.wmf)|*.bmp;*.gif;*.jpg;*.png;*.tif;*.wmf;" & _
                                        "| Windows Bitmap (*.bmp)|*.bmp" & "| GIF (*.gif)|*.gif" & _
                                        "| JPEG (*.jpg)|*.jpg" & "| Portable Network Graphics (*.png)|*.png" & _
                                        "| TIFF (*.tif)|*.tif" & "| Windows Meta File (*.wmf)|*.wmf"
            OpenFileDialog1.Title = "Bild-Datei laden"
        Else
            OpenFileDialog1.Filter = "Images (*.bmp;*.gif;*.jpg;*.png;*.tif;*.wmf)|*.bmp;*.gif;*.jpg;*.png;*.tif;*.wmf;" & _
                                        "| Windows Bitmap (*.bmp)|*.bmp" & "| GIF (*.gif)|*.gif" & _
                                        "| JPEG (*.jpg)|*.jpg" & "| Portable Network Graphics (*.png)|*.png" & _
                                        "| TIFF (*.tif)|*.tif" & "| Windows Meta File (*.wmf)|*.wmf"
            OpenFileDialog1.Title = "Load Image File"
        End If
        Me.OpenFileDialog1.FileName = fimg
        reti = Me.OpenFileDialog1.ShowDialog()
        fimg = Me.OpenFileDialog1.FileName
        If (reti = vbCancel) Then
            Exit Sub
        End If

        ' Bild einlesen
        img = New System.Drawing.Bitmap(fimg)

        If (img.PixelFormat.ToString.EndsWith("Indexed") = True) Then
            ' Convert from Paletted/Indexed Image
            displayState(0, "Convert from Paletted/Indexed Image") : Application.DoEvents()
            img = locRPSindexedImg.convertFromIndexed(img)
            displayState(1, "Convert from Paletted/Indexed Image")
        End If

        ' Bild anzeigen
        PictureBoxImage.Image = img
        PictureBoxImage.Tag = "used"

        ' Scroll Bars setzen
        setImageScrollBars()
        Application.DoEvents()

        ' Image Info anzeigen
        histo.plotImageInfo(objgr_result, img)

    End Sub

    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripMenuItem.Click
        ' Save File
        Dim img As System.Drawing.Bitmap
        Dim fmt As System.Drawing.Imaging.ImageFormat
        Dim fimg As String
        Dim reti As Integer

        ' Default
        fimg = ""

        ' Datei-Auswahl
        Me.SaveFileDialog1.InitialDirectory = Application.StartupPath
        If (pubLanguage = enumLang.Deutsch) Then
            SaveFileDialog1.Filter = "Windows Bitmap (*.bmp)|*.bmp" & "| GIF (*.gif)|*.gif" & _
                                        "| JPEG (*.jpg)|*.jpg" & "| Portable Network Graphics (*.png)|*.png" & _
                                        "| TIFF (*.tif)|*.tif" & "| Windows Meta File (*.wmf)|*.wmf"
            SaveFileDialog1.Title = "Bild-Datei speichern"
        Else
            SaveFileDialog1.Filter = "Windows Bitmap (*.bmp)|*.bmp" & "| GIF (*.gif)|*.gif" & _
                                        "| JPEG (*.jpg)|*.jpg" & "| Portable Network Graphics (*.png)|*.png" & _
                                        "| TIFF (*.tif)|*.tif" & "| Windows Meta File (*.wmf)|*.wmf"
            SaveFileDialog1.Title = "Save Image File"
        End If
        Me.SaveFileDialog1.FileName = fimg
        reti = Me.SaveFileDialog1.ShowDialog()
        fimg = Me.SaveFileDialog1.FileName
        If (reti = vbCancel) Then
            Exit Sub
        End If

        ' Format
        fmt = System.Drawing.Imaging.ImageFormat.Bmp
        If (fimg.Substring(fimg.LastIndexOf(".")).CompareTo(".bmp")) Then
            fmt = System.Drawing.Imaging.ImageFormat.Bmp
        ElseIf (fimg.Substring(fimg.LastIndexOf(".")).CompareTo(".gif")) Then
            fmt = System.Drawing.Imaging.ImageFormat.Gif
        ElseIf (fimg.Substring(fimg.LastIndexOf(".")).CompareTo(".jpg")) Then
            fmt = System.Drawing.Imaging.ImageFormat.Jpeg
        ElseIf (fimg.Substring(fimg.LastIndexOf(".")).CompareTo(".png")) Then
            fmt = System.Drawing.Imaging.ImageFormat.Png
        ElseIf (fimg.Substring(fimg.LastIndexOf(".")).CompareTo(".tif")) Then
            fmt = System.Drawing.Imaging.ImageFormat.Tiff
        ElseIf (fimg.Substring(fimg.LastIndexOf(".")).CompareTo(".wmf")) Then
            fmt = System.Drawing.Imaging.ImageFormat.Wmf
        End If

        ' Bild nehmen
        img = PictureBoxImage.Image

        ' Bild speichern
        img.Save(fimg, fmt)

    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        ' Exit Application
        Close()

    End Sub


    Private Sub HistogramToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HistogramToolStripMenuItem.Click
        ' Calculate Histogram
        Dim img As System.Drawing.Bitmap
        Dim histo As New RPShistogram
        Dim colsp As Integer
        Dim ret As Boolean
        Dim vmax As Integer

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Color Space
        colsp = ComboBoxColorSpace.SelectedIndex

        ' Bild-Daten
        img = Me.PictureBoxImage.Image

        ' Result loeschen
        objgr_result.Clear(Color.Silver)

        ' Histogram
        vmax = Me.PictureBoxResult.Height
        If (colsp = 0) Then
            ret = histo.binnedHistogram(img, enumChannel.RGB)
            If (ret = True) Then histo.plotHistogram(objgr_result, enumChannel.Red, 1, vmax)
            If (ret = True) Then histo.plotHistogram(objgr_result, enumChannel.Green, 2, vmax)
            If (ret = True) Then histo.plotHistogram(objgr_result, enumChannel.Blue, 3, vmax)
        ElseIf (colsp = 1) Then
            ret = histo.binnedHistogram(img, enumChannel.CMY)
            If (ret = True) Then histo.plotHistogram(objgr_result, enumChannel.Cyan, 1, vmax)
            If (ret = True) Then histo.plotHistogram(objgr_result, enumChannel.Magenta, 2, vmax)
            If (ret = True) Then histo.plotHistogram(objgr_result, enumChannel.Yellow, 3, vmax)
        ElseIf (colsp = 2) Then
            ret = histo.binnedHistogram(img, enumChannel.HSV)
            If (ret = True) Then histo.plotHistogram(objgr_result, enumChannel.HSV_Hue, 1, vmax)
            If (ret = True) Then histo.plotHistogram(objgr_result, enumChannel.HSV_Saturation, 2, vmax)
            If (ret = True) Then histo.plotHistogram(objgr_result, enumChannel.HSV_Value, 3, vmax)
        ElseIf (colsp = 3) Then
            ret = histo.binnedHistogram(img, enumChannel.HLS)
            If (ret = True) Then histo.plotHistogram(objgr_result, enumChannel.HLS_Hue, 1, vmax)
            If (ret = True) Then histo.plotHistogram(objgr_result, enumChannel.HLS_Luminance, 2, vmax)
            If (ret = True) Then histo.plotHistogram(objgr_result, enumChannel.HLS_Saturation, 3, vmax)
        End If

        ' Image Info
        histo.plotImageInfo(objgr_result, img)

        'Dim tmprpscolorspace As New RPScolorSpace
        'Dim a(2) As Integer
        'Dim ed(2) As Double
        'a(0) = 63
        'a(1) = 127
        'a(2) = 255
        'ed = tmprpscolorspace.RGBtoHLS(a)
        'MsgBox(ed(0) & "  " & ed(1) & " " & ed(2))
        'a = tmprpscolorspace.HLStoRGB(ed)
        'MsgBox(a(0) & "  " & a(1) & " " & a(2))

    End Sub

    Private Sub StatisticsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StatisticsToolStripMenuItem.Click
        ' Calculate Statistical Data
        Dim img As System.Drawing.Bitmap
        Dim histo As New RPShistogram
        Dim colsp As Integer
        Dim ret As Boolean
        Dim vmax As Integer

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Color Space
        colsp = ComboBoxColorSpace.SelectedIndex

        ' Bild-Daten
        img = Me.PictureBoxImage.Image

        ' Result loeschen
        objgr_result.Clear(Color.Silver)

        ' Histogram
        vmax = Me.PictureBoxResult.Height
        If (colsp = 0) Then
            ret = histo.binnedHistogram(img, enumChannel.RGB)
            If (ret = True) Then histo.plotStatistics(objgr_result, enumChannel.Red, 1, vmax)
            If (ret = True) Then histo.plotStatistics(objgr_result, enumChannel.Green, 2, vmax)
            If (ret = True) Then histo.plotStatistics(objgr_result, enumChannel.Blue, 3, vmax)
        ElseIf (colsp = 1) Then
            ret = histo.binnedHistogram(img, enumChannel.CMY)
            If (ret = True) Then histo.plotStatistics(objgr_result, enumChannel.Cyan, 1, vmax)
            If (ret = True) Then histo.plotStatistics(objgr_result, enumChannel.Magenta, 2, vmax)
            If (ret = True) Then histo.plotStatistics(objgr_result, enumChannel.Yellow, 3, vmax)
        ElseIf (colsp = 2) Then
            ret = histo.binnedHistogram(img, enumChannel.HSV)
            If (ret = True) Then histo.plotStatistics(objgr_result, enumChannel.HSV_Hue, 1, vmax)
            If (ret = True) Then histo.plotStatistics(objgr_result, enumChannel.HSV_Saturation, 2, vmax)
            If (ret = True) Then histo.plotStatistics(objgr_result, enumChannel.HSV_Value, 3, vmax)
        ElseIf (colsp = 3) Then
            ret = histo.binnedHistogram(img, enumChannel.HLS)
            If (ret = True) Then histo.plotStatistics(objgr_result, enumChannel.HLS_Hue, 1, vmax)
            If (ret = True) Then histo.plotStatistics(objgr_result, enumChannel.HLS_Luminance, 2, vmax)
            If (ret = True) Then histo.plotStatistics(objgr_result, enumChannel.HLS_Saturation, 3, vmax)
        End If

        ' Image Info
        histo.plotImageInfo(objgr_result, img)

    End Sub

    Private Sub ToGrayscaleToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToGrayscaleToolStripMenuItem.Click
        ' Convert Image to Grayscale Image
        Dim img As System.Drawing.Bitmap
        Dim po As New RPSpointOps
        Dim locRPSimgResult As New RPSimgResult
        Dim ans As String
        Dim typ As Integer

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Desaturation Factor?
        ans = "0"
        typ = 0
        While (typ < 1 Or typ > 3)
            ans = InputBox("Type in Color Weighting Type:" & vbCrLf & _
                           "(1) Equal" & vbCrLf & _
                           "(2) Television" & vbCrLf & _
                           "(3) ITU-BT.709", "Grayscale Image", "1")
            typ = Val(ans)
        End While

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Grayscale Image
        pubCalcType = enumCalcType.pointOps
        displayState(0, "Grayscale Image") : Application.DoEvents()
        locRPSimgResult = po.grayscaleImage(img, typ)
        If (locRPSimgResult.ans = True) Then displayState(1, "Grayscale Image") Else displayState(-1, "Grayscale Image")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub ToBinaryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToBinaryToolStripMenuItem.Click
        ' Convert Image to Binary Image
        Dim img As System.Drawing.Bitmap
        Dim po As New RPSpointOps
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Binary Image
        pubCalcType = enumCalcType.pointOps
        displayState(0, "Binary Image") : Application.DoEvents()
        locRPSimgResult = po.binaryImage(img)
        If (locRPSimgResult.ans = True) Then displayState(1, "Binary Image") Else displayState(-1, "Binary Image")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub StepBackToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StepBackToolStripMenuItem.Click
        ' Restore the Image before

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        If (pubCalcType = enumCalcType.pointOps) Then
            ' Bild anzeigen
            Me.PictureBoxImage.Image = pubimg

        ElseIf (pubCalcType = enumCalcType.filtering) Then
            ' Bild anzeigen
            Me.PictureBoxImage.Image = pubimg

        ElseIf (pubCalcType = enumCalcType.geoTrafos) Then
            ' Bild anzeigen
            Me.PictureBoxImage.Image = pubimg

        End If

    End Sub


    Private Sub InvertImgToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InvertImgToolStripMenuItem.Click
        ' Invert Image
        Dim img As System.Drawing.Bitmap
        Dim po As New RPSpointOps
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Image Inversion
        pubCalcType = enumCalcType.pointOps
        displayState(0, "Invert Image") : Application.DoEvents()
        locRPSimgResult = po.invertImage(img)
        If (locRPSimgResult.ans = True) Then displayState(1, "Invert Image") Else displayState(-1, "Invert Image")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub ChangeBrightToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChangeBrightToolStripMenuItem.Click
        ' Change Brightness of Image
        Dim img As System.Drawing.Bitmap
        Dim po As New RPSpointOps
        Dim locRPSimgResult As New RPSimgResult
        Dim ans As String
        Dim chg As Integer

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Brighten or darken?
        ans = "0"
        chg = 256
        While (chg < -255 Or chg > 255)
            ans = InputBox("Type in Change Value (-255 ... 0 ... +255):", "Change Brightness", "32")
            chg = Val(ans)
        End While

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Change Brightness
        pubCalcType = enumCalcType.pointOps
        displayState(0, "Change Brightness") : Application.DoEvents()
        locRPSimgResult = po.changeBrightness(img, Math.Sign(chg), Math.Abs(chg))
        If (locRPSimgResult.ans = True) Then displayState(1, "Change Brightness") Else displayState(-1, "Change Brightness")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub AutoContrastToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AutoContrastToolStripMenuItem.Click
        ' Calculate Auto Contrast
        Dim img As System.Drawing.Bitmap
        Dim po As New RPSpointOps
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Auto Contrast
        pubCalcType = enumCalcType.pointOps
        displayState(0, "Auto Contrast") : Application.DoEvents()
        locRPSimgResult = po.autoContrast(img)
        If (locRPSimgResult.ans = True) Then displayState(1, "Auto Contrast") Else displayState(-1, "Auto Contrast")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub HistoEqualToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HistoEqualToolStripMenuItem.Click
        ' Calculate Histogram Equalization
        Dim img As System.Drawing.Bitmap
        Dim po As New RPSpointOps
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Histogram Equalization
        pubCalcType = enumCalcType.pointOps
        displayState(0, "Histogram Equalization") : Application.DoEvents()
        locRPSimgResult = po.histoEqualization(img)
        If (locRPSimgResult.ans = True) Then displayState(1, "Histogram Equalization") Else displayState(-1, "Histogram Equalization")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub GammaCorrToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GammaCorrToolStripMenuItem.Click
        ' Calculate Gamma Correction
        Dim img As System.Drawing.Bitmap
        Dim po As New RPSpointOps
        Dim locRPSimgResult As New RPSimgResult
        Dim ans As String
        Dim gam As Double

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Gamma Value?
        ans = "0"
        gam = 0
        While (gam < 0.25 Or gam > 4.0)
            ans = InputBox("Type in Gamma Value (0.25 ... 1.0 ... 4.0):", "Gamma Correction", "0.45")
            gam = Val(ans)
        End While

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Gamma Correction
        pubCalcType = enumCalcType.pointOps
        displayState(0, "Gamma Correction") : Application.DoEvents()
        locRPSimgResult = po.gammaCorrection(img, gam)
        If (locRPSimgResult.ans = True) Then displayState(1, "Gamma Correction") Else displayState(-1, "Gamma Correction")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub QuantizationToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles QuantizationToolStripMenuItem.Click
        ' Calculate Image Quantization
        Dim img As System.Drawing.Bitmap
        Dim po As New RPSpointOps
        Dim locRPSimgResult As New RPSimgResult
        Dim ans As String
        Dim stp As Integer

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Gamma Value?
        ans = "0"
        stp = 0
        While (stp < 1 Or stp > 256)
            ans = InputBox("Type in Number of Steps (256|128|64|32|16|8|4|2|1):", "Image Quantization", "8")
            stp = Val(ans)
        End While

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Image Quantization
        pubCalcType = enumCalcType.pointOps
        displayState(0, "Image Quantization") : Application.DoEvents()
        locRPSimgResult = po.imageQuantization(img, stp)
        If (locRPSimgResult.ans = True) Then displayState(1, "Image Quantization") Else displayState(-1, "Image Quantization")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub DesaturationToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DesaturationToolStripMenuItem.Click
        ' Calculate Image Desaturation
        Dim img As System.Drawing.Bitmap
        Dim po As New RPSpointOps
        Dim locRPSimgResult As New RPSimgResult
        Dim ans As String
        Dim fac As Double

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Desaturation Factor?
        ans = "0"
        fac = -1.0
        While (fac < 0.0 Or fac > 1.0)
            ans = InputBox("Type in Desaturation Factor (0.0 ... 0.5 ... 1.0):", "Image Desaturation", "0.5")
            fac = Val(ans)
        End While

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Image Desaturation
        pubCalcType = enumCalcType.pointOps
        displayState(0, "Image Desaturation") : Application.DoEvents()
        locRPSimgResult = po.imageDesaturation(img, fac)
        If (locRPSimgResult.ans = True) Then displayState(1, "Image Desaturation") Else displayState(-1, "Image Desaturation")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub


    Private Sub BoxFilterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BoxFilterToolStripMenuItem.Click
        ' Filtering with Box Filter
        Dim img As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Box Filter
        pubCalcType = enumCalcType.filtering
        displayState(0, "Box Filter") : Application.DoEvents()
        locRPSimgResult = af.boxFilter(img)
        If (locRPSimgResult.ans = True) Then displayState(1, "Box Filter") Else displayState(-1, "Box Filter")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub WeightedBoxToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WeightedBoxToolStripMenuItem.Click
        ' Filtering with Weighted Box Filter
        Dim img As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Weighted Box Filter
        pubCalcType = enumCalcType.filtering
        displayState(0, "Weighted Box Filter") : Application.DoEvents()
        locRPSimgResult = af.weightedFilter(img, enumWeightFilter.RoundFilter)
        If (locRPSimgResult.ans = True) Then displayState(1, "Weighted Box Filter") Else displayState(-1, "Weighted Box Filter")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub GaussFilterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GaussFilterToolStripMenuItem.Click
        ' Filtering with Gauss Filter
        Dim img As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Gauss Filter
        pubCalcType = enumCalcType.filtering
        displayState(0, "Gauss Filter") : Application.DoEvents()
        locRPSimgResult = af.weightedFilter(img, enumWeightFilter.GaussFilter_3x3)
        If (locRPSimgResult.ans = True) Then displayState(1, "Gauss Filter") Else displayState(-1, "Gauss Filter")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub LaplaceFilterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EdgeSharpToolStripMenuItem.Click
        ' Filtering by Edge Sharpening
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult
        Dim ans As String
        Dim fac As Double

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Masking Factor?
        ans = "0"
        fac = 0
        While (fac < 0.25 Or fac > 4.0)
            ans = InputBox("Type in Sharpening Factor (0.25 ... 1.0 ... 4.0):", "Edge Sharpening", "1.0")
            fac = Val(ans)
        End While

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = img.Clone

        ' Edge Unsharpening with Laplace Filter
        pubCalcType = enumCalcType.filtering
        displayState(0, "Edge Sharpening") : Application.DoEvents()
        locRPSimgResult = af.weightedFilter(img, enumWeightFilter.LaplaceFilter_3x3)
        locRPSimgResult = af.edgeSharpening(wrk, locRPSimgResult.img, fac)
        If (locRPSimgResult.ans = True) Then displayState(1, "Edge Sharpening") Else displayState(-1, "Edge Sharpening")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub UnsharpMaskToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UnsharpMaskToolStripMenuItem.Click
        ' Filtering by Unsharp Masking
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult
        Dim ans As String
        Dim fac As Double

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Masking Factor?
        ans = "0"
        fac = 0
        While (fac < 0.25 Or fac > 4.0)
            ans = InputBox("Type in Sharpening Factor (0.25 ... 1.0 ... 4.0):", "Unsharp Masking", "2.0")
            fac = Val(ans)
        End While

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = img.Clone

        ' Unsharp Masking with Gauss Filter
        pubCalcType = enumCalcType.filtering
        displayState(0, "Unsharp Masking") : Application.DoEvents()
        locRPSimgResult = af.weightedFilter(img, enumWeightFilter.GaussFilter_5x5)
        locRPSimgResult = af.unsharpMasking(wrk, locRPSimgResult.img, fac)
        If (locRPSimgResult.ans = True) Then displayState(1, "Unsharp Masking") Else displayState(-1, "Unsharp Masking")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub MinFilterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MinFilterToolStripMenuItem.Click
        ' Filtering with Minimum Filter
        Dim img As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Minimum Filter
        pubCalcType = enumCalcType.filtering
        displayState(0, "Minimum Filter") : Application.DoEvents()
        locRPSimgResult = af.minmaxMedianFilter(img, enumNonLinFilter.Minimum)
        If (locRPSimgResult.ans = True) Then displayState(1, "Minimum Filter") Else displayState(-1, "Minimum Filter")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub MaxFilterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MaxFilterToolStripMenuItem.Click
        ' Filtering with Maximum Filter
        Dim img As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Maximum Filter
        pubCalcType = enumCalcType.filtering
        displayState(0, "Maximum Filter") : Application.DoEvents()
        locRPSimgResult = af.minmaxMedianFilter(img, enumNonLinFilter.Maximum)
        If (locRPSimgResult.ans = True) Then displayState(1, "Maximum Filter") Else displayState(-1, "Maximum Filter")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub MedFilterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MedFilterToolStripMenuItem.Click
        ' Filtering with Median Filter
        Dim img As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Median Filter
        pubCalcType = enumCalcType.filtering
        displayState(0, "Median Filter") : Application.DoEvents()
        locRPSimgResult = af.minmaxMedianFilter(img, enumNonLinFilter.Median)
        If (locRPSimgResult.ans = True) Then displayState(1, "Median Filter") Else displayState(-1, "Median Filter")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub LaplaceOperatorToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LaplaceOperatorToolStripMenuItem.Click
        ' Filtering with Laplace Filter
        Dim img As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Laplace Filter
        pubCalcType = enumCalcType.filtering
        displayState(0, "Laplace Filter") : Application.DoEvents()
        locRPSimgResult = af.weightedFilter(img, enumWeightFilter.LaplaceFilter_5x5)
        If (locRPSimgResult.ans = True) Then displayState(1, "Laplace Filter") Else displayState(-1, "Laplace Filter")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub SobelOperatorToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SobelOperatorToolStripMenuItem.Click
        ' Filtering with Sobel Operator
        Dim img As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Sobel Operator
        pubCalcType = enumCalcType.filtering
        displayState(0, "Sobel Operator") : Application.DoEvents()
        locRPSimgResult = af.gradientFilter(img, enumGradFilter.SobelFilter_3x3, enumGradOutput.EdgeStrength)
        If (locRPSimgResult.ans = True) Then displayState(1, "Sobel Operator") Else displayState(-1, "Sobel Operator")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub PrewittOperatorToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrewittOperatorToolStripMenuItem.Click
        ' Filtering with Prewitt Operator
        Dim img As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Sobel Operator
        pubCalcType = enumCalcType.filtering
        displayState(0, "Prewitt Operator") : Application.DoEvents()
        locRPSimgResult = af.gradientFilter(img, enumGradFilter.PrewittFilter_3x3, enumGradOutput.EdgeStrength)
        If (locRPSimgResult.ans = True) Then displayState(1, "Prewitt Operator") Else displayState(-1, "Prewitt Operator")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub ErosionToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ErosionToolStripMenuItem.Click
        ' Filtering by Morphological Erosion
        Dim img As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Morphological Erosion
        pubCalcType = enumCalcType.filtering
        displayState(0, "Morphological Erosion") : Application.DoEvents()
        locRPSimgResult = af.morphologFilter(img, enumMorphOper.Erosion, enumMorphFilter.Neighbourhood8_3x3)
        If (locRPSimgResult.ans = True) Then displayState(1, "Morphological Erosion") Else displayState(-1, "Morphological Erosion")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub DilatationToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DilatationToolStripMenuItem.Click
        ' Filtering by Morphological Dilatation
        Dim img As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        ' Backup
        pubimg = img.Clone

        ' Morphological Dilatation
        pubCalcType = enumCalcType.filtering
        displayState(0, "Morphological Dilatation") : Application.DoEvents()
        locRPSimgResult = af.morphologFilter(img, enumMorphOper.Dilatation, enumMorphFilter.Neighbourhood8_3x3)
        If (locRPSimgResult.ans = True) Then displayState(1, "Morphological Dilatation") Else displayState(-1, "Morphological Dilatation")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub OpeningToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpeningToolStripMenuItem.Click
        ' Filtering by Morphological Opening
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult
        Dim ans As String
        Dim fil As Integer
        Dim filnum As Integer

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Filter Element?
        ans = "0"
        fil = 0
        While (fil < 1 Or fil > 3)
            ans = InputBox("Choose a Filter Element:" & vbCrLf & _
                           "(1) 4-Neighbourhood 3x3" & vbCrLf & _
                           "(2) 8-Neighbourhood 3x3" & vbCrLf & _
                           "(3) Disk-Formed 5x5", "Filter Element", "2")
            fil = Val(ans)
        End While
        If (fil = 1) Then
            filnum = enumMorphFilter.Neighbourhood4_3x3
        ElseIf (fil = 2) Then
            filnum = enumMorphFilter.Neighbourhood8_3x3
        ElseIf (fil = 3) Then
            filnum = enumMorphFilter.DiskFormedFilter_5x5
        End If

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = wrk.Clone

        ' Morphological Opening
        pubCalcType = enumCalcType.filtering
        displayState(0, "Morphological Opening") : Application.DoEvents()
        locRPSimgResult = af.morphologFilter(img, enumMorphOper.Erosion, filnum)
        locRPSimgResult = af.morphologFilter(img, enumMorphOper.Dilatation, filnum)
        If (locRPSimgResult.ans = True) Then displayState(1, "Morphological Opening") Else displayState(-1, "Morphological Opening")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub ClosingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClosingToolStripMenuItem.Click
        ' Filtering by Morphological Closing
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim af As New RPSfiltering
        Dim locRPSimgResult As New RPSimgResult
        Dim ans As String
        Dim fil As Integer
        Dim filnum As Integer

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Filter Element?
        ans = "0"
        fil = 0
        While (fil < 1 Or fil > 3)
            ans = InputBox("Choose a Filter Element:" & vbCrLf & _
                           "(1) 4-Neighbourhood 3x3" & vbCrLf & _
                           "(2) 8-Neighbourhood 3x3" & vbCrLf & _
                           "(3) Disk-Formed 5x5", "Filter Element", "2")
            fil = Val(ans)
        End While
        If (fil = 1) Then
            filnum = enumMorphFilter.Neighbourhood4_3x3
        ElseIf (fil = 2) Then
            filnum = enumMorphFilter.Neighbourhood8_3x3
        ElseIf (fil = 3) Then
            filnum = enumMorphFilter.DiskFormedFilter_5x5
        End If

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = wrk.Clone

        ' Morphological Closing
        pubCalcType = enumCalcType.filtering
        displayState(0, "Morphological Closing") : Application.DoEvents()
        locRPSimgResult = af.morphologFilter(img, enumMorphOper.Dilatation, filnum)
        locRPSimgResult = af.morphologFilter(img, enumMorphOper.Erosion, filnum)
        If (locRPSimgResult.ans = True) Then displayState(1, "Morphological Closing") Else displayState(-1, "Morphological Closing")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub


    Private Sub TranslationToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TranslationToolStripMenuItem.Click
        ' Geom. Translation
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim locRPSimgResult As New RPSimgResult
        Dim dx, dy As Double

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = wrk.Clone

        ' Parameter Input Window
        pubWinPar.Text = "Geometric Translation"
        pubWinPar.LabelPar1.Text = "Translation dx (-width...+width)"
        pubWinPar.TextBoxPar1.Text = "5"
        pubWinPar.LabelPar2.Text = "Translation dy (-height...+height)"
        pubWinPar.TextBoxPar2.Text = "5"
        pubWinPar.LabelPar1.Visible = True
        pubWinPar.TextBoxPar1.Visible = True
        pubWinPar.LabelPar2.Visible = True
        pubWinPar.TextBoxPar2.Visible = True
        pubWinPar.LabelPar3.Visible = False
        pubWinPar.TextBoxPar3.Visible = False
        pubWinPar.LabelPar4.Visible = False
        pubWinPar.TextBoxPar4.Visible = False
        pubWinPar.LabelPar5.Visible = False
        pubWinPar.TextBoxPar5.Visible = False
        pubWinPar.parCount = 2
        pubWinPar.parLim(1, 1) = -img.Width : pubWinPar.parLim(1, 2) = img.Width
        pubWinPar.parLim(2, 1) = -img.Height : pubWinPar.parLim(2, 2) = img.Height
        pubWinPar.ShowDialog()
        pubWinPar.BringToFront()

        If (pubWinPar.parDone < pubWinPar.parCount) Then Exit Sub

        ' Shift dx, dy ?
        'dx = 5
        'dy = 5 ' test data
        dx = Val(pubWinPar.TextBoxPar1.Text)
        dy = Val(pubWinPar.TextBoxPar2.Text)

        ' Geometric Translation
        pubCalcType = enumCalcType.geoTrafos
        displayState(0, "Geometric Translation") : Application.DoEvents()
        Dim map As RPSgeoMapping.Translation = New RPSgeoMapping.Translation(dx, dy)
        Dim ipol As RPSgeoInterp.PixelInterpolator = New RPSgeoInterp.BicubicInterpolator(0.5)
        locRPSimgResult = map.applyTo(img, ipol)
        If (locRPSimgResult.ans = True) Then displayState(1, "Geometric Translation") Else displayState(-1, "Geometric Translation")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub ScalingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ScalingToolStripMenuItem.Click
        ' Geom. Scaling
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim locRPSimgResult As New RPSimgResult
        Dim sx, sy As Double

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Parameter Input Window
        pubWinPar.Text = "Geometric Scaling"
        pubWinPar.LabelPar1.Text = "Scaling Factor sx (0.1...1.0...10.0)"
        pubWinPar.TextBoxPar1.Text = "2.0"
        pubWinPar.LabelPar2.Text = "Scaling Factor sy (0.1...1.0...10.0)"
        pubWinPar.TextBoxPar2.Text = "0.5"
        pubWinPar.LabelPar1.Visible = True
        pubWinPar.TextBoxPar1.Visible = True
        pubWinPar.LabelPar2.Visible = True
        pubWinPar.TextBoxPar2.Visible = True
        pubWinPar.LabelPar3.Visible = False
        pubWinPar.TextBoxPar3.Visible = False
        pubWinPar.LabelPar4.Visible = False
        pubWinPar.TextBoxPar4.Visible = False
        pubWinPar.LabelPar5.Visible = False
        pubWinPar.TextBoxPar5.Visible = False
        pubWinPar.parCount = 2
        pubWinPar.parLim(1, 1) = 0.1 : pubWinPar.parLim(1, 2) = 10.0
        pubWinPar.parLim(2, 1) = 0.1 : pubWinPar.parLim(2, 2) = 10.0
        pubWinPar.ShowDialog()
        pubWinPar.BringToFront()

        If (pubWinPar.parDone < pubWinPar.parCount) Then Exit Sub

        ' Scaling Factor sx, sy ?
        'sx = 2.0
        'sy = 0.5   ' test data
        sx = Val(pubWinPar.TextBoxPar1.Text)
        sy = Val(pubWinPar.TextBoxPar2.Text)

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = wrk.Clone

        ' Geometric Scaling
        pubCalcType = enumCalcType.geoTrafos
        displayState(0, "Geometric Scaling") : Application.DoEvents()
        Dim map As RPSgeoMapping.Scaling = New RPSgeoMapping.Scaling(1 / sx, 1 / sy)
        Dim ipol As RPSgeoInterp.PixelInterpolator = New RPSgeoInterp.BicubicInterpolator(0.5)
        locRPSimgResult = map.applyTo(img, ipol)
        If (locRPSimgResult.ans = True) Then displayState(1, "Geometric Scaling") Else displayState(-1, "Geometric Scaling")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub RotationToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RotationToolStripMenuItem.Click
        ' Geom. Rotation
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim locRPSimgResult As New RPSimgResult
        Dim angle As Double

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Parameter Input Window
        pubWinPar.Text = "Geometric Rotation"
        pubWinPar.LabelPar1.Text = "Rotation Angle[deg] (-360...+360)"
        pubWinPar.TextBoxPar1.Text = "15"
        pubWinPar.LabelPar1.Visible = True
        pubWinPar.TextBoxPar1.Visible = True
        pubWinPar.LabelPar2.Visible = False
        pubWinPar.TextBoxPar2.Visible = False
        pubWinPar.LabelPar3.Visible = False
        pubWinPar.TextBoxPar3.Visible = False
        pubWinPar.LabelPar4.Visible = False
        pubWinPar.TextBoxPar4.Visible = False
        pubWinPar.LabelPar5.Visible = False
        pubWinPar.TextBoxPar5.Visible = False
        pubWinPar.parCount = 1
        pubWinPar.parLim(1, 1) = -360.0 : pubWinPar.parLim(1, 2) = 360.0
        pubWinPar.ShowDialog()
        pubWinPar.BringToFront()

        If (pubWinPar.parDone < pubWinPar.parCount) Then Exit Sub

        ' Rotation Angle[deg] ?
        'angle = 15 ' test data
        angle = Val(pubWinPar.TextBoxPar1.Text)

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = wrk.Clone

        ' Geometric Rotation
        pubCalcType = enumCalcType.geoTrafos
        displayState(0, "Geometric Rotation") : Application.DoEvents()
        Dim map As RPSgeoMapping.Rotation = New RPSgeoMapping.Rotation((2 * Math.PI * angle) / 360)
        Dim ipol As RPSgeoInterp.PixelInterpolator = New RPSgeoInterp.BicubicInterpolator(0.5)
        locRPSimgResult = map.applyTo(img, ipol)
        If (locRPSimgResult.ans = True) Then displayState(1, "Geometric Rotation") Else displayState(-1, "Geometric Rotation")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub ShearToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShearToolStripMenuItem.Click
        ' Geom. Shear
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim locRPSimgResult As New RPSimgResult
        Dim bx, by As Double

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Parameter Input Window
        pubWinPar.Text = "Geometric Shear"
        pubWinPar.LabelPar1.Text = "Shear Angle[deg] bx (-90...+90)"
        pubWinPar.TextBoxPar1.Text = "10"
        pubWinPar.LabelPar2.Text = "Shear Angle[deg] by (-90...+90)"
        pubWinPar.TextBoxPar2.Text = "20"
        pubWinPar.LabelPar1.Visible = True
        pubWinPar.TextBoxPar1.Visible = True
        pubWinPar.LabelPar2.Visible = True
        pubWinPar.TextBoxPar2.Visible = True
        pubWinPar.LabelPar3.Visible = False
        pubWinPar.TextBoxPar3.Visible = False
        pubWinPar.LabelPar4.Visible = False
        pubWinPar.TextBoxPar4.Visible = False
        pubWinPar.LabelPar5.Visible = False
        pubWinPar.TextBoxPar5.Visible = False
        pubWinPar.parCount = 2
        pubWinPar.parLim(1, 1) = -90.0 : pubWinPar.parLim(1, 2) = 90.0
        pubWinPar.parLim(2, 1) = -90.0 : pubWinPar.parLim(2, 2) = 90.0
        pubWinPar.ShowDialog()
        pubWinPar.BringToFront()

        If (pubWinPar.parDone < pubWinPar.parCount) Then Exit Sub

        ' Shear Angle[deg] bx, by ?
        'bx = 10
        'by = 20    ' test data
        bx = Val(pubWinPar.TextBoxPar1.Text)
        by = Val(pubWinPar.TextBoxPar2.Text)

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = wrk.Clone

        ' Geometric Shear
        pubCalcType = enumCalcType.geoTrafos
        displayState(0, "Geometric Shear") : Application.DoEvents()
        Dim map As RPSgeoMapping.Shear = New RPSgeoMapping.Shear((2 * Math.PI * bx) / 360, (2 * Math.PI * by) / 360)
        Dim ipol As RPSgeoInterp.PixelInterpolator = New RPSgeoInterp.BicubicInterpolator(0.5)
        locRPSimgResult = map.applyTo(img, ipol)
        If (locRPSimgResult.ans = True) Then displayState(1, "Geometric Shear") Else displayState(-1, "Geometric Shear")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub AffineAllToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AffineAllToolStripMenuItem.Click
        ' Geom. Affine-All
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim locRPSimgResult As New RPSimgResult
        Dim p1, p2, p3 As Point2Ddbl
        Dim q1, q2, q3 As Point2Ddbl

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        If (pubpick_done = False) Then
            ' Pick
            MsgBox("Please pick 3 identical Points: each first from then to Location!", MsgBoxStyle.Information, "Identical Points")
            pubActiveFunc = enumActiveFunc.AffineAll
            pubpick_count = 0

            Exit Sub

        End If

        pubpick_done = False

        ' Identical Points ?
        'p1 = New Point2Ddbl(0, 0)
        'p2 = New Point2Ddbl(200, 0)
        'p3 = New Point2Ddbl(200, 200)
        'q1 = New Point2Ddbl(0, 60)
        'q2 = New Point2Ddbl(200, 20)
        'q3 = New Point2Ddbl(150, 200)  ' test data
        p1 = pubpick_points1(0)
        p2 = pubpick_points1(1)
        p3 = pubpick_points1(2)
        q1 = pubpick_points2(0)
        q2 = pubpick_points2(1)
        q3 = pubpick_points2(2)

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = wrk.Clone

        ' Geometric Affine-All
        pubCalcType = enumCalcType.geoTrafos
        displayState(0, "Geometric Affine-All") : Application.DoEvents()
        Dim map As New RPSgeoMapping.AffineMapping(0, 0, 0, 0, 0, 0, True)
        map.makeMapping(p1, p2, p3, q1, q2, q3)
        Dim ipol As RPSgeoInterp.PixelInterpolator = New RPSgeoInterp.BicubicInterpolator(0.5)
        locRPSimgResult = map.applyTo(img, ipol)
        If (locRPSimgResult.ans = True) Then displayState(1, "Geometric Affine-All") Else displayState(-1, "Geometric Affine-All")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub ProjecMappingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProjecMappingToolStripMenuItem.Click
        ' Geom. Projective Mapping
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim locRPSimgResult As New RPSimgResult
        Dim p1, p2, p3, p4 As Point2Ddbl
        Dim q1, q2, q3, q4 As Point2Ddbl

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        If (pubpick_done = False) Then
            ' Pick
            MsgBox("Please pick 4 identical Points: each first from then to Location!", MsgBoxStyle.Information, "Identical Points")
            pubActiveFunc = enumActiveFunc.Projective
            pubpick_count = 0

            Exit Sub

        End If

        pubpick_done = False

        ' Identical Points ?
        'p1 = New Point2Ddbl(0, 0)
        'p2 = New Point2Ddbl(200, 0)
        'p3 = New Point2Ddbl(200, 200)
        'p4 = New Point2Ddbl(0, 200)
        'q1 = New Point2Ddbl(0, 60)
        'q2 = New Point2Ddbl(200, 20)
        'q3 = New Point2Ddbl(150, 200)
        'q4 = New Point2Ddbl(30, 100)  ' test data
        p1 = pubpick_points1(0)
        p2 = pubpick_points1(1)
        p3 = pubpick_points1(2)
        p4 = pubpick_points1(3)
        q1 = pubpick_points2(0)
        q2 = pubpick_points2(1)
        q3 = pubpick_points2(2)
        q4 = pubpick_points2(3)

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = wrk.Clone

        ' Projective Mapping
        pubCalcType = enumCalcType.geoTrafos
        displayState(0, "Projective Mapping") : Application.DoEvents()
        Dim map As New RPSgeoMapping.ProjectiveMapping(0, 0, 0, 0, 0, 0, 0, 0, True)
        map.makeMapping(p1, p2, p3, p4, q1, q2, q3, q4)
        Dim ipol As RPSgeoInterp.PixelInterpolator = New RPSgeoInterp.BicubicInterpolator(0.5)
        locRPSimgResult = map.applyTo(img, ipol)
        If (locRPSimgResult.ans = True) Then displayState(1, "Projective Mapping") Else displayState(-1, "Projective Mapping")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub BilinearMappingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BilinearMappingToolStripMenuItem.Click
        ' Geom. Bilinear Mapping
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim locRPSimgResult As New RPSimgResult
        Dim p1, p2, p3, p4 As Point2Ddbl
        Dim q1, q2, q3, q4 As Point2Ddbl

        MsgBox("not implemented", MsgBoxStyle.Information, "Matrix Library needed")

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        If (pubpick_done = False) Then
            ' Pick
            MsgBox("Please pick 4 identical Points: each first from then to Location!", MsgBoxStyle.Information, "Identical Points")
            pubActiveFunc = enumActiveFunc.Bilinear
            pubpick_count = 0

            Exit Sub

        End If

        pubpick_done = False

        ' Identical Points ?
        'p1 = New Point2Ddbl(0, 0)
        'p2 = New Point2Ddbl(200, 0)
        'p3 = New Point2Ddbl(200, 200)
        'p4 = New Point2Ddbl(0, 200)
        'q1 = New Point2Ddbl(0, 60)
        'q2 = New Point2Ddbl(200, 20)
        'q3 = New Point2Ddbl(150, 200)
        'q4 = New Point2Ddbl(30, 100)  ' test data
        p1 = pubpick_points1(0)
        p2 = pubpick_points1(1)
        p3 = pubpick_points1(2)
        p4 = pubpick_points1(3)
        q1 = pubpick_points2(0)
        q2 = pubpick_points2(1)
        q3 = pubpick_points2(2)
        q4 = pubpick_points2(3)

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = wrk.Clone

        ' Bilinear Mapping
        'pubCalcType = enumCalcType.geoTrafos
        'displayState(0, "Bilinear Mapping") : Application.DoEvents()
        'Dim map As New RPSgeoMapping.BilinearMapping(0, 0, 0, 0, 0, 0, 0, 0, True)
        'map.makeInverseMapping(p1, p2, p3, p4, q1, q2, q3, q4)
        'Dim ipol As RPSgeoInterp.PixelInterpolator = New RPSgeoInterp.BicubicInterpolator(0.5)
        'locRPSimgResult = map.applyTo(img, ipol)
        'If (locRPSimgResult.ans = True) Then displayState(1, "Bilinear Mapping") Else displayState(-1, "Bilinear Mapping")

        ' Bild anzeigen
        'Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub TwirlMappingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TwirlMappingToolStripMenuItem.Click
        ' Geom. Twirl Mapping
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim locRPSimgResult As New RPSimgResult
        Dim xcenter, ycenter As Double
        Dim angle, radius As Double

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = wrk.Clone

        ' Parameter Input Window
        pubWinPar.Text = "Twirl Mapping"
        pubWinPar.LabelPar1.Text = "Twirl Center in x (0...width)"
        pubWinPar.TextBoxPar1.Text = Int(0.5 * img.Width).ToString
        pubWinPar.LabelPar2.Text = "Twirl Center in y (0...height)"
        pubWinPar.TextBoxPar2.Text = Int(0.5 * img.Height).ToString
        pubWinPar.LabelPar3.Text = "Twirl Radius (0...max(width,height))"
        pubWinPar.TextBoxPar3.Text = Int(Math.Sqrt((0.5 * img.Width) ^ 2 + (0.5 * img.Height) ^ 2)).ToString
        pubWinPar.LabelPar4.Text = "Twirl Angle[deg] (-90...+90)"
        pubWinPar.TextBoxPar4.Text = "45.0"
        pubWinPar.LabelPar1.Visible = True
        pubWinPar.TextBoxPar1.Visible = True
        pubWinPar.LabelPar2.Visible = True
        pubWinPar.TextBoxPar2.Visible = True
        pubWinPar.LabelPar3.Visible = True
        pubWinPar.TextBoxPar3.Visible = True
        pubWinPar.LabelPar4.Visible = True
        pubWinPar.TextBoxPar4.Visible = True
        pubWinPar.LabelPar5.Visible = False
        pubWinPar.TextBoxPar5.Visible = False
        pubWinPar.parCount = 4
        pubWinPar.parLim(1, 1) = 0 : pubWinPar.parLim(1, 2) = img.Width
        pubWinPar.parLim(2, 1) = 0 : pubWinPar.parLim(2, 2) = img.Height
        pubWinPar.parLim(3, 1) = 0 : pubWinPar.parLim(3, 2) = Math.Max(img.Width, img.Height)
        pubWinPar.parLim(4, 1) = -90.0 : pubWinPar.parLim(4, 2) = 90.0
        pubWinPar.ShowDialog()
        pubWinPar.BringToFront()

        If (pubWinPar.parDone < pubWinPar.parCount) Then Exit Sub

        ' Center (xcenter, ycenter), radius, angle[rad] ?
        'xcenter = 0.5 * img.Width
        'ycenter = 0.5 * img.Height
        'radius = Math.Sqrt(xcenter * xcenter + ycenter * ycenter)
        'angle = 45     ' test data
        xcenter = Val(pubWinPar.TextBoxPar1.Text)
        ycenter = Val(pubWinPar.TextBoxPar2.Text)
        radius = Val(pubWinPar.TextBoxPar3.Text)
        angle = Val(pubWinPar.TextBoxPar4.Text)

        ' Twirl Mapping
        pubCalcType = enumCalcType.geoTrafos
        displayState(0, "Twirl Mapping") : Application.DoEvents()
        Dim map As RPSgeoMapping.TwirlMapping = New RPSgeoMapping.TwirlMapping(xcenter, ycenter, angle * Math.PI / 180.0, radius, True)
        map.makeInverseMapping(xcenter, ycenter, angle, radius)
        Dim ipol As RPSgeoInterp.PixelInterpolator = New RPSgeoInterp.BicubicInterpolator(0.5)
        locRPSimgResult = map.applyTo(img, ipol)
        If (locRPSimgResult.ans = True) Then displayState(1, "Twirl Mapping") Else displayState(-1, "Twirl Mapping")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub RippleMappingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RippleMappingToolStripMenuItem.Click
        ' Geom. Ripple Mapping
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim locRPSimgResult As New RPSimgResult
        Dim xWavel, yWavel As Double
        Dim xAmpl, yAmpl As Double

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = wrk.Clone

        ' Parameter Input Window
        pubWinPar.Text = "Ripple Mapping"
        pubWinPar.LabelPar1.Text = "Ripple Wavelength in x (2...width)"
        pubWinPar.TextBoxPar1.Text = "120"
        pubWinPar.LabelPar2.Text = "Ripple Wavelength in y (2...height)"
        pubWinPar.TextBoxPar2.Text = "250"
        pubWinPar.LabelPar3.Text = "Ripple Amplitude in x (2...width)"
        pubWinPar.TextBoxPar3.Text = "10"
        pubWinPar.LabelPar4.Text = "Ripple Amplitude in y (2...height)"
        pubWinPar.TextBoxPar4.Text = "12"
        pubWinPar.LabelPar1.Visible = True
        pubWinPar.TextBoxPar1.Visible = True
        pubWinPar.LabelPar2.Visible = True
        pubWinPar.TextBoxPar2.Visible = True
        pubWinPar.LabelPar3.Visible = True
        pubWinPar.TextBoxPar3.Visible = True
        pubWinPar.LabelPar4.Visible = True
        pubWinPar.TextBoxPar4.Visible = True
        pubWinPar.LabelPar5.Visible = False
        pubWinPar.TextBoxPar5.Visible = False
        pubWinPar.parCount = 4
        pubWinPar.parLim(1, 1) = 2 : pubWinPar.parLim(1, 2) = img.Width
        pubWinPar.parLim(2, 1) = 2 : pubWinPar.parLim(2, 2) = img.Height
        pubWinPar.parLim(3, 1) = 2 : pubWinPar.parLim(3, 2) = img.Width
        pubWinPar.parLim(4, 1) = 2 : pubWinPar.parLim(4, 2) = img.Height
        pubWinPar.ShowDialog()
        pubWinPar.BringToFront()

        If (pubWinPar.parDone < pubWinPar.parCount) Then Exit Sub

        ' Wave Parameters xWavel, yWavel, xAmpl, yAmpl ?
        'xWavel = 120
        'yWavel = 250
        'xAmpl = 10
        'yAmpl = 10 ' test data
        xWavel = Val(pubWinPar.TextBoxPar1.Text)
        yWavel = Val(pubWinPar.TextBoxPar2.Text)
        xAmpl = Val(pubWinPar.TextBoxPar3.Text)
        yAmpl = Val(pubWinPar.TextBoxPar4.Text)

        ' Ripple Mapping
        pubCalcType = enumCalcType.geoTrafos
        displayState(0, "Ripple Mapping") : Application.DoEvents()
        Dim map As RPSgeoMapping.RippleMapping = New RPSgeoMapping.RippleMapping(xWavel, xAmpl, yWavel, yAmpl, True)
        map.makeInverseMapping(xWavel, xAmpl, yWavel, yAmpl)
        Dim ipol As RPSgeoInterp.PixelInterpolator = New RPSgeoInterp.BicubicInterpolator(0.5)
        locRPSimgResult = map.applyTo(img, ipol)
        If (locRPSimgResult.ans = True) Then displayState(1, "Ripple Mapping") Else displayState(-1, "Ripple Mapping")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub

    Private Sub SphereMappingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SphereMappingToolStripMenuItem.Click
        ' Geom. Sphere Mapping
        Dim img As System.Drawing.Bitmap
        Dim wrk As System.Drawing.Bitmap
        Dim locRPSimgResult As New RPSimgResult
        Dim xcenter, ycenter As Double
        Dim radius, refIdx As Double

        ' Check
        If (Me.PictureBoxImage.Tag = "") Then Exit Sub

        ' Bild-Daten
        img = Me.PictureBoxImage.Image
        wrk = img.Clone
        ' Backup
        pubimg = wrk.Clone

        ' Parameter Input Window
        pubWinPar.Text = "Sphere Mapping"
        pubWinPar.LabelPar1.Text = "Sphere Center in x (0...width)"
        pubWinPar.TextBoxPar1.Text = Int(0.5 * img.Width).ToString
        pubWinPar.LabelPar2.Text = "Sphere Center in y (0...height)"
        pubWinPar.TextBoxPar2.Text = Int(0.5 * img.Height).ToString
        pubWinPar.LabelPar3.Text = "Sphere Radius (0...max(width,height))"
        pubWinPar.TextBoxPar3.Text = Math.Min(Int(0.5 * img.Width), Int(0.5 * img.Height)).ToString
        pubWinPar.LabelPar4.Text = "Refraction Index (0.1...5.0)"
        pubWinPar.TextBoxPar4.Text = "1.8"
        pubWinPar.LabelPar1.Visible = True
        pubWinPar.TextBoxPar1.Visible = True
        pubWinPar.LabelPar2.Visible = True
        pubWinPar.TextBoxPar2.Visible = True
        pubWinPar.LabelPar3.Visible = True
        pubWinPar.TextBoxPar3.Visible = True
        pubWinPar.LabelPar4.Visible = True
        pubWinPar.TextBoxPar4.Visible = True
        pubWinPar.LabelPar5.Visible = False
        pubWinPar.TextBoxPar5.Visible = False
        pubWinPar.parCount = 4
        pubWinPar.parLim(1, 1) = 0 : pubWinPar.parLim(1, 2) = img.Width
        pubWinPar.parLim(2, 1) = 0 : pubWinPar.parLim(2, 2) = img.Height
        pubWinPar.parLim(3, 1) = 0 : pubWinPar.parLim(3, 2) = Math.Max(img.Width, img.Height)
        pubWinPar.parLim(4, 1) = 0.1 : pubWinPar.parLim(4, 2) = 5.0
        pubWinPar.ShowDialog()
        pubWinPar.BringToFront()

        If (pubWinPar.parDone < pubWinPar.parCount) Then Exit Sub

        ' Center (xcenter, ycenter), radius, refIdx ?
        'xcenter = 0.5 * img.Width + 10
        'ycenter = 0.5 * img.Height
        'radius = 0.5 * img.Height
        'refIdx = 1.8    ' refraction index ' test data
        xcenter = Val(pubWinPar.TextBoxPar1.Text)
        ycenter = Val(pubWinPar.TextBoxPar2.Text)
        radius = Val(pubWinPar.TextBoxPar3.Text)
        refIdx = Val(pubWinPar.TextBoxPar4.Text)

        ' Sphere Mapping
        pubCalcType = enumCalcType.geoTrafos
        displayState(0, "Sphere Mapping") : Application.DoEvents()
        Dim map As RPSgeoMapping.SphereMapping = New RPSgeoMapping.SphereMapping(xcenter, ycenter, radius, refIdx, True)
        map.makeInverseMapping(xcenter, ycenter, radius, refIdx)
        Dim ipol As RPSgeoInterp.PixelInterpolator = New RPSgeoInterp.BicubicInterpolator(0.5)
        locRPSimgResult = map.applyTo(img, ipol)
        If (locRPSimgResult.ans = True) Then displayState(1, "Sphere Mapping") Else displayState(-1, "Sphere Mapping")

        ' Bild anzeigen
        Me.PictureBoxImage.Image = locRPSimgResult.img

    End Sub


    Public Sub displayState(ByVal state As Integer, ByVal what As String)
        ' Display State of Calculation

        If (state = 0) Then
            Me.LabelState.Text = what & " ..."
            Me.LabelState.BackColor = Color.Yellow
        ElseIf (state = 1) Then
            Me.LabelState.Text = what & " done"
            Me.LabelState.BackColor = Color.Lime
        ElseIf (state = -1) Then
            Me.LabelState.Text = what & " failed"
            Me.LabelState.BackColor = Color.Red
        End If

    End Sub

    Private Sub HScrollBar1_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HScrollBar1.Scroll
        ' Update
        PictureBoxImage.Refresh()

    End Sub

    Private Sub VScrollBar1_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles VScrollBar1.Scroll
        ' Update
        PictureBoxImage.Refresh()

    End Sub

    Public Sub setImageScrollBars()
        ' Set Scroll Bars of Image

        ' Bildlaufleisten einblenden, wenn die Bildbreite (-hoehe) groeszer als die PictureBox ist
        Me.HScrollBar1.Visible = Me.PictureBoxImage.Image.Width > Me.PictureBoxImage.Width
        Me.VScrollBar1.Visible = Me.PictureBoxImage.Image.Height > Me.PictureBoxImage.Height

        ' nochmals pruefen und sichtbare Bildlaufleisten mit beruecksichtigen
        If (Me.VScrollBar1.Visible = True) Then
            Me.HScrollBar1.Visible = Me.PictureBoxImage.Image.Width > (Me.PictureBoxImage.Width - Me.VScrollBar1.Width)
        End If
        If (Me.HScrollBar1.Visible = True) Then
            Me.VScrollBar1.Visible = Me.PictureBoxImage.Image.Height > (Me.PictureBoxImage.Height - Me.HScrollBar1.Height)
        End If

        ' horizontale Bildlaufleiste konfigurieren
        Me.HScrollBar1.Value = 0
        Me.HScrollBar1.Minimum = 0
        Me.HScrollBar1.Maximum = Me.PictureBoxImage.Image.Width - 1
        Me.HScrollBar1.SmallChange = 5
        ' LargeChange auf Anzeigenbreite setzen
        If (Me.HScrollBar1.Visible = True) Then
            If (Me.VScrollBar1.Visible = True) Then
                Me.HScrollBar1.LargeChange = Me.PictureBoxImage.Width - Me.VScrollBar1.Width
            Else
                Me.HScrollBar1.LargeChange = Me.PictureBoxImage.Width
            End If
        End If

        ' vertikable Bildlaufleiste konfigurieren
        Me.VScrollBar1.Value = 0
        Me.VScrollBar1.Minimum = 0
        Me.VScrollBar1.Maximum = Me.PictureBoxImage.Image.Height - 1
        Me.VScrollBar1.SmallChange = 5
        ' LargeChange auf Anzeigenhoehe setzen
        If (Me.VScrollBar1.Visible = True) Then
            If (Me.HScrollBar1.Visible = True) Then
                Me.VScrollBar1.LargeChange = Me.PictureBoxImage.Height - Me.HScrollBar1.Height
            Else
                Me.VScrollBar1.LargeChange = Me.PictureBoxImage.Height
            End If
        End If

    End Sub

    Private Sub PictureBoxImage_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBoxImage.Paint
        Dim gc = e.Graphics

        gc.Clear(Color.White)

        If (Me.PictureBoxImage.Tag <> "") Then
            ' Korrektur fuer moeglicherweise eingeblendete Bildlaufleisten
            Dim corrW As Integer = 0
            Dim corrH As Integer = 0

            If (Me.VScrollBar1.Visible = True) Then
                corrW = Me.VScrollBar1.Width
            End If
            If (Me.HScrollBar1.Visible = True) Then
                corrH = Me.HScrollBar1.Height
            End If

            gc.DrawImage(Me.PictureBoxImage.Image, New Rectangle(0, 0, Me.PictureBoxImage.Right - corrW, Me.PictureBoxImage.Bottom - corrH), _
                        New Rectangle(Me.HScrollBar1.Value, Me.VScrollBar1.Value, Me.PictureBoxImage.Right - corrW, Me.PictureBoxImage.Bottom - corrH), GraphicsUnit.Pixel)


        End If

    End Sub

    Private Sub PictureBoxImage_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBoxImage.MouseUp
        ' Pick

        Dim locPoint As Point2Ddbl = New Point2Ddbl(e.X, e.Y)
        If (pubpick_count Mod 2 = 0) Then
            ' register from Point
            pubpick_points1.Add(locPoint)
        Else
            ' register to Point
            pubpick_points2.Add(locPoint)
        End If
        pubpick_count = pubpick_count + 1

        ' plot
        plotPickPoints(pubpick_points1.Count - 1)

        ' jump back when registering finished
        If (pubActiveFunc = enumActiveFunc.AffineAll) Then
            If (pubpick_count = 6) Then
                pubpick_done = True
                AffineAllToolStripMenuItem_Click(sender, e)
            End If
        ElseIf (pubActiveFunc = enumActiveFunc.Projective) Then
            If (pubpick_count = 8) Then
                pubpick_done = True
                ProjecMappingToolStripMenuItem_Click(sender, e)
            End If
        ElseIf (pubActiveFunc = enumActiveFunc.Bilinear) Then
            If (pubpick_count = 8) Then
                pubpick_done = True
                BilinearMappingToolStripMenuItem_Click(sender, e)
            End If
        Else
            Exit Sub
        End If

    End Sub

    Public Sub plotPickPoints(ByVal startIndex As Integer)
        ' Plot Pick Points
        Dim u, v As Integer
        Dim i As Integer

        For i = startIndex To pubpick_points1.Count - 1
            ' from Points
            u = Int(pubpick_points1(i).getX)
            v = Int(pubpick_points1(i).getY)
            objgr_image.DrawEllipse(New System.Drawing.Pen(Color.Magenta, 1), u, v, 1, 1)
        Next

        For i = startIndex To pubpick_points2.Count - 1
            ' to Points
            u = Int(pubpick_points2(i).getX)
            v = Int(pubpick_points2(i).getY)
            objgr_image.DrawEllipse(New System.Drawing.Pen(Color.Cyan, 1), u, v, 1, 1)
        Next

    End Sub

End Class
